<?php
include "fefunctions.php";
include "iocommand.php";
start_session();

   /***********************************************************************
   *    Copyright � 2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/

$_SESSION["surveyView"] = "survey.php";
$_SESSION["comparing"] = "0";
$_SESSION["deviceAction"] = "";

$bgcolor = "#ffffff";
?>
<html>
  <head>
    <meta http-equiv='content-type' content='text/html; charset=UTF-8'>
    <title>HP Insight Diagnostics</title>
    <link rel='stylesheet' type='text/css' href='stylesheets/main.css'>
    <link rel='stylesheet' type='text/css' href='stylesheets/header.css'>
    <style> body { background:white; } </style>
    <SCRIPT LANGUAGE='JavaScript' SRC='dom-drag.js'></SCRIPT>
    <SCRIPT LANGUAGE='JavaScript' SRC='menufunctions.js'></SCRIPT>
<script language=Javascript>

function swap(objct, image,treeIndex) //swaps tree images from x to -
{
  if(document.getElementById(objct).style.visibility == 'visible')
  {
    document.getElementById(objct).style.display = 'none';
    document.getElementById(objct).style.visibility = 'hidden';
    document.images[image].src = 'tree_graphic_plus.png';
    parent.parent.frames.headerFrame.testTree[treeIndex] = "hidden";
  }
  else
  {
    document.getElementById(objct).style.display = 'inline';
    document.getElementById(objct).style.visibility = 'visible';
    document.images[image].src = 'tree_graphic_minus.png';
   parent.parent.frames.headerFrame.testTree[treeIndex] = 'visible';
  }
}

function checkDeviceTests(dev, numTests, menuIndex)
{
  hideScheduledMessage();
  swap('menu'+menuIndex,'image'+menuIndex, menuIndex);

  for(element=0; element <= numTests; element++)
  {
    document.diagnoseForm.elements[dev+element].checked=document.diagnoseForm.elements[dev+0].checked;
    // set the array that keeps track of the tests that are selected/deselected 
    if (parent.parent.frames.headerFrame.testsSelected[dev+element] == "true")
      parent.parent.frames.headerFrame.testsSelected[dev+element] = "";
    else
      parent.parent.frames.headerFrame.testsSelected[dev+element] = "true";
  }    
}

function getParameters(device, test, elroy)
{
  hideScheduledMessage();

  // set the array that keeps track of the tests that are selected/deselected 
  if (parent.parent.frames.headerFrame.testsSelected[elroy] == "true")
    parent.parent.frames.headerFrame.testsSelected[elroy] = "";
  else
    parent.parent.frames.headerFrame.testsSelected[elroy] = "true";

  // now get the parameters
  document.diagnoseForm.device.value = device;
  document.diagnoseForm.test.value = test;
  parent.parent.frames.dataFrame.frames.parmFrame.document.parametersForm.submit();
}

function checkAll()
{
  hideScheduledMessage();

  for (var i = 0; i < document.diagnoseForm.elements.length; i++)
  {
    if (document.diagnoseForm.elements[i].type == 'checkbox' && document.diagnoseForm.elements[i].name != 'stopOnError')
      document.diagnoseForm.elements[i].checked = true;

    // update the array that keeps track of the selected tests
	  //parent.parent.frames.headerFrame.testsSelected[i] = 'true';
  }
}

function uncheckAll()
{
  hideScheduledMessage();

  for (var i = 0; i < document.diagnoseForm.elements.length; i++)
  {
    if (document.diagnoseForm.elements[i].type == 'checkbox' && document.diagnoseForm.elements[i].name != 'stopOnError')
      document.diagnoseForm.elements[i].checked = false;

    // update the array that keeps track of the selected tests
	  parent.parent.frames.headerFrame.testsSelected[i] = '';
  }
}


function validate(parameter)
{
  var val = new Number(parameter);
  if(val != parameter)
  {
    alert("<?php echo TR('MSG_NUMERIC_ONLY'); ?>");
    return false;
  }
  else if(val <= 0)
  {
    alert("<?php echo TR('MSG_NUMERIC_ONLY'); ?>" +" > 0");
    return false;
  }
  
  return true;
}

/*******************************************************************************************************
* This fuction submits the parameter page and then after the parameter page is submitted the parameter *
* page will call the BeginTesting function on the customtest page.  This has to be done this way or we *
* will lock up due to the fact that both pages have to access the idResult session variable.		       *
*******************************************************************************************************/
function SubmitParametersFirst()
{
  parent.parent.frames.dataFrame.frames.parmFrame.document.parametersForm.begin.value='1';
  parent.parent.frames.dataFrame.frames.parmFrame.document.parametersForm.submit();
}

function initPage()
{
    /*
  theaboutHandle = document.getElementById("abouthandleIt");
  theaboutRoot   = document.getElementById("aboutrootIt");
  Drag.init(theaboutHandle, theaboutRoot);
  */
  top.frames.dataFrame1.enableTabs();
}

</script>

  </head>
  
<?php
  $diagnose = 0;
  $diagnose = $_REQUEST["send"];

  if ($diagnose) // if tests have been submitted
  {
    printf("<body>");
	  $dom = domxml_new_doc("1.0");  
	  $startProcess = $dom->create_element("startProcess");
    $diagRunDiagnosis = $dom->create_element("diagRunDiagnosis");
  
    while(list($key, $value) = each($HTTP_POST_VARS))
    {
      if (strstr($key, "+diagnose"))
      {
        $deviceName = substr($key,0,strpos($key,"+diagnose"));        

        $diagRunDiagnosis->set_attribute("jobCaption", htmlentities(TR("MSG_HARDWARE_DIAGNOSIS"),ENT_QUOTES,'utf-8'));
        $diagRunDiagnosis->set_attribute("language", GetLanguage());
	      $runDiagnosis = $dom->create_element("runDiagnosis");
        $idXml = new DomDocument($_SESSION["idResult"]);
        $idXpath = @xpath_new_context($idXml->document_element());
        $device = @xpath_eval($idXpath, "/diagOutput/category/device[@name='". $deviceName . "']");
	      $num_devices = count($device);
	      if ($num_devices)
        { // if found the device

	        $deviceNode = $device->nodeset[0];
          $component = $deviceNode->get_attribute("component");
          $caption = $deviceNode->get_attribute("caption");

          $runDiagnosis->set_attribute("device", $deviceName);
          $runDiagnosis->set_attribute("component", $component);
          $runDiagnosis->set_attribute("caption", $caption);

          $diagRunDiagnosis->append_child($runDiagnosis);          

	      }
      }
    }
    $startProcess->append_child($diagRunDiagnosis);
    $dom->append_child($startProcess);
    
	  // debug - display diagRun xml to web page
    //echo htmlentities($dom->html_dump_mem());

  	// Submit the diagRun command					  
    $runErrors = "";
    $runStatus = "";
    if (GetLanguage() == "ja")
      $runDiagnosisStr = sprintf("%s", $dom->dump_mem(true, "UTF-8"));
    else
      $runDiagnosisStr = sprintf("%s", $dom->dump_mem());
    $_SESSION["diagRun"] = $runDiagnosisStr;
    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $runDiagnosisStr, $runStatus, $runErrors);
    $xmldoc = new DomDocument($runStatus);

    $_SESSION["statusxml"] = "";
    $_SESSION["lastTest"] = 99;
    $_SESSION["lastPrompt"] = "";
    $_SESSION["lastLoop"] = "";
    $_SESSION["statusDrawn"] = "false";
    unset($_SESSION["completedTests"]);
    $_SESSION["lastLoop"] = "";
    $_SESSION["REFRESH_RATE"] = 2;
    $_SESSION["diagnosisResult"] = "";
    
    $rootElement = $xmldoc->document_element();
    $_SESSION["testpid"] = $rootElement->get_attribute("processID");
	 	
    //$_SESSION["diagnosisstatus"] = "";
    //$_SESSION["testpid"] = "2712";
    // GO TO STATUS PAGE NOW...
    printf("<script language=\"JavaScript\">\n");
    printf("parent.frames.dataFrame1.doTab(3);\n");
    printf("parent.frames.dataFrame2.location = 'statusheader.php';");
    printf("</script>\n");
  }
  else // build the test page
  {
?>
<body TOPMARGIN=0 MARGINHEIGHT=0 onload="initPage();"> 
<FORM name='diagnoseForm' method=post>
  <table border=0 cellspacing=0 cellpadding=0 width='100%' height='100%' bgcolor=white>
    <tr>
      <td width=5>
      </td>
      <td valign=top>
        <table width=100% border=0 cellspacing=0 cellpadding=0>
          <tr>
            <td width=6 bgcolor=#cccccc></td>       
            <td colspan=2 valign=top>
              <table>
                <?php
                if (GetLanguage() == "en")
                {
                ?>
                  <tr valign=top><td width=900><?php echo "Insight Diagnostics' new Diagnose feature enables high system availability by performing various non-intrusive, in-depth system and component checks while the operating system is up and running.";?></td></tr>
                  <tr><td height=20>&nbsp;</td></tr>
                  <tr valign=top><td width=500><?php echo "<b>Smart Array Drive Diagnosis</b>"; ?></td></tr>
                  <tr><td height=20>&nbsp;</td></tr>
                  <tr valign=top><td width=900><?php echo "Smart Array Drive Diagnosis is the premier feature of hardware diagnosis, and it provides the ability to assess the health of hard disk drives attached to Smart Array Controllers and select Modular Smart Array (MSA) products.  For usage information, best practices, and a complete support listing, review the HP Insight Diagnostics User Guide located at www.hp.com/servers/diags."; ?></td></tr>
                  <tr><td height=20>&nbsp;</td></tr>                
                <?php
                }
                else
                {
                ?>                
                  <tr valign=top><td width=500><?php echo TR("MSG_DIAGNOSIS_DESC");?></td></tr>
                  <tr><td height=20>&nbsp;</td></tr>
                <?php  
                }
                ?>
              </table>
                
<?php
  CreateAboutDiv();

$ci = new client_info();
  if (strstr($ci->get_client_platform(), "indows"))
  {
    if (strstr($ci->get_client_browser(), "IE"))
      printf("<div style='height:230px;overflow:auto'>\n");
    else
      printf("<div style='height:307px;overflow:auto'>\n");
  }
  else
  {
    if (IsPhoenix())
      printf("<div style='height:400px;overflow:auto'>\n");
    else
      printf("<div style='height:260px;overflow:auto'>\n");
  }

?>
<table>
<?php
  $idXml = new DomDocument($_SESSION["idResult"]);
  $idXpath = @xpath_new_context($idXml->document_element());
  $devices = @xpath_eval($idXpath, "/diagOutput/category/device[@diagnosable='1']");

  $categories = @xpath_eval($idXpath, "/diagOutput/category");
  $num_categories = count($categories->nodeset);
  $element = 5; // need to keep track of the number of elements on the page - starts at 5 b/c of the test mode fields
  $menuIndex = 0; // need to keep track of menu number

  if (IsDiagnosable())
  {
  
    printf("<tr valign=top><td colspan=2><b>%s:</b></td></tr><tr><td width=5></td><td nowrap>", TR("MSG_SELECT_DEVICE_DIAGNOSE"));
    for ($i=0; $i < $num_categories; $i++)
    {
      $categoryNode = $categories->nodeset[$i];
      $categoryXpath = xpath_new_context($categoryNode);
      $devices = xpath_eval($categoryXpath, "/device[@diagnosable='1']");	
      $num_devices = count($devices->nodeset);
	    if ($num_devices)
	    {
              
        $catPrint = 0;
        $categoryName = $categoryNode->get_attribute("name");
        $categoryCaption = $categoryNode->get_attribute("caption");
        $categoryDescription = $categoryNode->get_attribute("description");
    	
        // do this with a sprintf b/c we do not know if we really want to display it yet b/c we don't know if we have tests to display
        // based on the testFilter
        $oss = sprintf("      <span onclick=swap('menu%d','image%d',%d);>\n", $menuIndex, $menuIndex, $menuIndex);
        $oss = $oss . sprintf("        <img src='tree_graphic_plus.png' name='image%d'><b>&nbsp;%s<b>\n", $menuIndex, $categoryCaption);
        $oss = $oss . sprintf("      </span>\n      <br>\n");
        $oss = $oss . sprintf("      <div id='menu%d' style='Visibility:hidden; display:none;'>\n", $menuIndex);

        for ($j=0; $j < $num_devices; $j++)
        {
          $deviceNode = $devices->nodeset[$j];
	        $deviceXpath = @xpath_new_context($deviceNode);
          $deviceName = $deviceNode->get_attribute("name");
          $deviceCaption = $deviceNode->get_attribute("caption");
          $deviceDescription = $deviceNode->get_attribute("description");

          if (!$catPrint) // and if we have not already printed the category div
          {
            printf("%s", $oss);
            $catPrint = 1;  // do not print the category div twice
            $menuIndex++;
          }

          $oss = $oss . sprintf("        &nbsp;&nbsp;&nbsp;&nbsp;\n");
          printf("        <input type=checkbox name='%s+diagnose'>\n", $deviceName);
		      $element++;
          printf("        <span title='%s'>\n", $deviceDescription);
          printf("          &nbsp;%s\n", $deviceCaption);
          printf("        </span>\n        <br>\n");
          $menuIndex++;
	      } // end for devices
        printf("      </div>\n");
	    } // end if num_devices
    }
  }
  else
  {
    if (GetLanguage == "en")                                            
      printf("<tr><td width=5></td><td colspan=3 nowrap><b>This device does not currently support the diagnose feature.</b>");
    else
      printf("<tr><td width=5></td><td colspan=3 nowrap><b>%s</b>", TR("MSG_DIAGNOSABLE_NOT_PRESENT"));
  }
?>
    </td>
  </tr>
</table>
</div>
<?php
    printf("</td>\n<td width=5 bgcolor=white></td>\n<td bgcolor=#cccccc width=5></td>\n</tr>\n");
    printf("<tr><td bgcolor=#cccccc height=5></td><td width=5 colspan=3></td><td bgcolor=#cccccc width=5></td></tr>\n");
    printf("<tr><td bgcolor=#cccccc width=5 colspan=5 height=5></td></tr>\n");
    printf("<tr><td colspan=5 height=5></td></tr>\n");
    printf("<tr><td colspan=5 height=10>\n");                                                                                                                                                               
    if (!IsOnline() || IsFactory())
      printf("<table border=0 width=100%%>\n<tr>\n<td width=65%%>%s</td>", MakeButton(TR("MSG_EXIT") ." ". TR("MSG_DIAGNOSTICS"), "parent.frames.headerFrame.exit();"));
    else
      printf("<table border=0 width=100%%>\n<tr>\n<td width=65%%>&nbsp;</td>");
	if (IsDiagnosable())
      printf("<td align=right>%s</td>\n</tr>\n", MakeButton(TR("MSG_DIAGNOSE"), "BeginTesting();"));
    printf("</table>\n\n");
      
    printf("</td></tr></table></td></tr></table>");
?>
<script language="Javascript">
var mediaArray = new Array();
<?php
  printf("%s", $ossmp);
?>
function expand_Collapse() 
{
  if(document.getElementById('expand_collapse').innerHTML == '<?php echo TR("MSG_EXPAND"); ?>')
  {
    document.getElementById('expand_collapse').innerHTML='<?php echo TR("MSG_COLLAPSE"); ?>';    
    for (i=0; i < <?php echo $menuIndex ?>; i++) 
    {
      document.getElementById('menu'+i).style.display = 'inline';
      document.getElementById('menu'+i).style.visibility = 'visible';
      document.images['image'+i].src = 'tree_graphic_minus.png';
	    parent.parent.frames.headerFrame.testTree[i] = 'visible';
    }
  }
  else
  {
    document.getElementById('expand_collapse').innerHTML='<?php echo TR("MSG_EXPAND"); ?>';
    for (i=0; i < <?php echo $menuIndex ?>; i++) 
    {
      document.getElementById('menu'+i).style.display = 'none';
      document.getElementById('menu'+i).style.visibility = 'hidden';
      document.images['image'+i].src = 'tree_graphic_plus.png';
	    parent.parent.frames.headerFrame.testTree[i] = 'hidden';
    }
  }
}

function growTrees(treeArray, select)
{
  if(parent.parent.frames.headerFrame.scheduledTest == "custom")
  {
    showScheduledMessage();
  }

  // expand the tree to it's last state
  var expanded=0;
  for (var i=0; i < <?php echo $menuIndex ?>; i++)
  {
	  if (treeArray[i] == "visible")
	  {
	    document.getElementById("menu"+i).style.display = 'inline';
      document.getElementById("menu"+i).style.visibility = 'visible';
      document.images["image"+i].src = 'tree_graphic_minus.png';
	    expanded++;
	  }	    
  }

  if(expanded == <?php echo $menuIndex ?>)
    document.getElementById('expand_collapse').innerHTML='<?php echo TR("MSG_COLLAPSE"); ?>';

  // check tests that were previously left checked
  for (var j=4; j < document.diagnoseForm.elements.length; j++)
  {
	  if (select[j] == "true")
	  {
	    document.diagnoseForm.elements[j].checked = "true";
	  }
  }
}

function BeginTesting()
{
  //parent.parent.frames.dataFrame.frames.parmFrame.document.parametersForm.submit();
  
  testSelected = 'false';
  for (var i = 0; i < document.diagnoseForm.elements.length; i++)
  {
    if (document.diagnoseForm.elements[i].type == 'checkbox' && document.diagnoseForm.elements[i].name != 'stopOnError')
	    if(document.diagnoseForm.elements[i].checked == true)
      {
        testSelected = 'true';
		  //  Media prompt crap
        var lastPrompt;
        for (var arrIndex=0; arrIndex < mediaArray.length; arrIndex++) 
        {
          if ((mediaArray[arrIndex] == document.diagnoseForm.elements[i].id) && (lastPrompt !=mediaArray[arrIndex]))
          {
            <?php printf("alert(\"%s \" +mediaArray[arrIndex]);\n", TR("MSG_PLEASE_INSERT_MEDIA")); ?> 
             lastPrompt = mediaArray[arrIndex];
          }
        }
      }
  }
  

  if(testSelected == 'true')
  {
    
	  document.diagnoseForm.send.value="1";
    document.diagnoseForm.submit();
  }
  else
   alert("<?php echo TR('MSG_PLEASE_SELECT_TEST'); ?>");
}
</script>


	  <input type='hidden' name='send' value='1'>
	  <input type='hidden' name='scheduleType' value='1'>
    <input type='hidden' name='scheduleHour' value=''/>
    <input type='hidden' name='scheduleMinute' value=''/>
    <input type='hidden' name='scheduleMode' value=''/>
    <input type='hidden' name='scheduleWeekdays' value=''/>
    <input type='hidden' name='scheduleMonths' value=''/>
    <input type='hidden' name='scheduleMonthdays' value=''/>

    <input type='hidden' name='testSubmit' value='1'>

</form>
<?php
  }
?>
<script language="Javascript" src="norightclick.js"></script>
</body></html>





